/***************************************************************************
                          ftpconnectiondialog.h  -  description                              
                             -------------------                                         
    begin                : Fri Dec 10 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef FTPCONNECTIONDIALOG_H
#define FTPCONNECTIONDIALOG_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
//Generated area. DO NOT EDIT!!!(end)
#include <basedialog.h>
#include "ftppluginfactory.h"
/**
  *@author Henrik Stormer
  */

class FtpConnectionDialog : public BaseDialog  {
   Q_OBJECT
public: 
	FtpConnectionDialog(QList<FtpConfiguration>& ConnectionList);
	~FtpConnectionDialog();

  FtpConfiguration* getConfiguration() {return _ActConfiguration;}

public slots:
  virtual void slotOk()  {slotSaveEntry();BaseDialog::slotOk();}
  void slotConnect(int)      {slotOk();}
  void slotNewEntry();
  void slotDeleteEntry();
  void slotSaveEntry();
  void slotHighlighted(int);
  void slotAnonymous(bool);
  void slotExtended();

protected:
  void enableDialog(bool bEnable);
	void initDialog();
  void saveEntries();
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *QGroupBox_1;
	QListBox *_Connections;
	QLineEdit *_Host;
	QLineEdit *_Dir;
	QLabel *QLabel_1;
	QLabel *QLabel_2;
	QLabel *QLabel_3;
	QSpinBox *_Port;
	QLabel *QLabel_4;
	QCheckBox *_Anonymous;
	QLineEdit *_User;
	QLineEdit *_Password;
	QPushButton *_Connect;
	QPushButton *_Cancel;
	QPushButton *_NewEntry;
	QPushButton *_SaveEntry;
	QPushButton *_DeleteEntry;
	QLabel *QLabel_5;
	QPushButton *_Extended;
	//Generated area. DO NOT EDIT!!!(end)

private:
  QList<FtpConfiguration>& _ConnectionList;
  QList<short>             _ColumnOrder;
  FtpConfiguration*        _ActConfiguration;
  int                      _ActConfigurationIndex;
};

#endif
