/***************************************************************************
                          generalfileplugin.h  -  description                              
                             -------------------                                         
    begin                : Tue Oct 5 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef GENERALFILEPLUGIN_H
#define GENERALFILEPLUGIN_H

#include <qstring.h>
#include "baseplugin.h"
#include <basepluginfactory.h>
#include "knc.h"
class MyListView;
/**
  *@author Henrik Stormer
  */
class GeneralFilePluginFactory;

class GeneralFilePlugin : public BasePlugin
{
public: 
	GeneralFilePlugin(GeneralFilePluginFactory* Factory);
	~GeneralFilePlugin();
  virtual bool isResponsible(QString Path, QString SubPath);
  virtual BasePluginFactory* getPluginFactory();
  virtual bool create(QString Path, MyListView* ListBox, QString CurrentItemName, bool ShowHiddenFiles);
  virtual QString cdUp(QString Path, QString& Name);
  virtual QString cdDown(QString Path, QString DownPath);

  virtual void insertEntry(MyListView* ListBox, QString Path, QString Name);
  virtual void removeEntry(MyListView* ListBox, QString Path, QString Name);

  virtual void recurseSubdir(QString Dir, QList<BaseFileInfo>& FileList, double& countFiles, double& sizeAll);

  virtual QString getType() {return "GeneralFilePlugin";}
  virtual bool makeDirectory(QString Path, QString Dir);
  virtual GeneralFilePlugin* clone(QString, QString) {return new GeneralFilePlugin(*this);}

  virtual bool getOwners(QStrList& OwnerList);
  virtual bool getGroups(QStrList& GroupList);

 protected:
  BaseFileInfo* generateFileInfo(QString Dir, QString Name);

  virtual void getsInactive(MyListView*) {}
 private:
  GeneralFilePluginFactory* _Factory;
};

class GeneralFilePluginFactory : public BasePluginFactory
{
public:
  GeneralFilePluginFactory();
  ~GeneralFilePluginFactory();
  virtual bool isResponsible(QString Path, QString SubPath);
  virtual GeneralFilePlugin* generatePlugin(QString Dir, QString SubDir) {return new GeneralFilePlugin(this);}
};


#endif









































