/***************************************************************************
                          helpfunc.cpp  -  description
                             -------------------
    begin                : Sun Nov 28 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <qstring.h>
#include <qdir.h>

bool ripPath (QString Path, QString Delimiter, QString& FirstPart, QString& LastPart)
{
  int pos = Path.find(Delimiter);
  if (pos != -1)
  {
    FirstPart = Path.left(pos);
    LastPart = Path.right(Path.length() - (pos + Delimiter.length()));
    return true;
  }
  return false;
}

//the Path is cutted in FirstPath and UpDir, f.e.:
// Path = /home/usr/hello World -> FirstPath = /home/usr, UpDir = hello World
bool cutUpPath(QString Path, QString& FirstPath, QString& UpDir)
{
  if (Path.right(1) == "/") Path.resize(Path.length());
  int pos = Path.findRev("/");
  if (pos != -1)
  {
     UpDir = Path.right(Path.length() - (pos + 1));
     FirstPath = Path.left(pos+1);
     return true;
  }
  return false;
}


QString canonicalPath(QString Path)
{
// QString SPath, Name;
// cutUpPath(Path, SPath, Name);
 QDir Dir(Path);
 if (Dir.exists())
  return Dir.canonicalPath() + "/"; // + "/" + Name;
 else
  return Path;
}






