/***************************************************************************
                          kURLcompletion.h  -  description                              
                             -------------------                                         
    begin                : Wed Feb 16 2000                                           
    copyright            : (C) 2000 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

/* 
 * KURLCompletion
 * Completion of URL's (currently just files), to
 * be connected to KLined() which emits signals for completion (Tab/Ctrl-S)
 * and rotation (Ctrl-D)
 *
 * 10/1997 Henner Zeller <zeller@think.de>
 * This code is based on Torben Weis' KFileEntry
 */

#ifndef kurlcompletion_h
#define kurlcompletion_h

#include <qstring.h>
#include <qstrlist.h>
#include <qobject.h>

class KURLCompletion : public QObject
{
    Q_OBJECT

public slots:
    void make_completion (const QString& StartDir);
    void make_rotation ();
    void edited (const char *);
    
signals:
    void setText (const char *);
	
public:
    KURLCompletion( const char *dir = "");
    ~KURLCompletion();

private:
    bool is_fileurl (QString &url, bool &ambigous_beginning) const;
    void GetList (QString dir, QString text, QString & match);
    bool CompleteDir (QString &dir);
    QString directory;

    bool new_guess, completed_dir, self_update;
    QString the_text;
    QStrList possibilityList;
    QString guess;
    QString qual_dir;
};

#endif
