/***************************************************************************
                          mycheckbox.cpp  -  description
                             -------------------
    begin                : Sat Sep 11 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "mycheckbox.h"
#include "qbrush.h"
#include "qdrawutil.h"
#include <iostream.h>

MyCheckBox::MyCheckBox(QWidget * parent, const char * name)
 : QCheckBox(parent, name), _State(0) //, _noState(false) //false)
{
  connect(this, SIGNAL(clicked()), SLOT(slotClicked()));
}

MyCheckBox::~MyCheckBox()
{
}

void MyCheckBox::slotClicked()
{
 if (_State == 0) _State = 2;  //set -> next state is noState!!
   else if (_State == 1) _State = 0;    //unset -> next state is set(0)
     else if (_State == 2) _State = 1;  //nostate -> goto set

 repaint();
}

void MyCheckBox::paintEvent( QPaintEvent *event )
{
 static QPainter paint;
 if (paint.isActive()) return;
 paint.begin(this);
 drawButton(&paint);
 paint.end();
}


void MyCheckBox :: drawButton(QPainter* paint)
{
 if (_State == 0) setOn(true);
 if (_State == 1) setOn(false);
 if ((_State == 0) || (_State == 1)) QCheckBox::drawButton(paint);
 else
 {
   GUIStyle	 gs = style();
   QColorGroup	 g  = colorGroup();
   int		 x, y;

   QFontMetrics fm = fontMetrics();
   QSize lsz = fm.size(ShowPrefix, text());
   QSize sz = QSize(13,13);
   x = gs == MotifStyle ? 1 : 0;
   y = (height() - lsz.height() + fm.height() - sz.height())/2;

   if ( gs == WindowsStyle )
   {		
     QBrush fill( g.background());
     qDrawWinPanel( paint, x, y, sz.width(), sz.height(), g, true, &fill );
   }
   if ( gs == MotifStyle ) 			// Motif check box
   {
     QBrush fill( g.dark() );
     qDrawShadePanel( paint, x, y, sz.width(), sz.height(), g, true, 2, &fill );
   }
   QCheckBox::drawButtonLabel(paint);
 }
}