/***************************************************************************
                          mycommandline.h  -  description                              
                             -------------------                                         
    begin                : Sun Jan 30 2000                                           
    copyright            : (C) 2000 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYCOMMANDLINE_H
#define MYCOMMANDLINE_H

#include <qwidget.h>
#include <klined.h>
#include <qlabel.h>
#include <kprocess.h>
#include <qintdict.h>
#include "kURLcompletion.h"

/**
  *@author Henrik Stormer
  */

class MyCommandLine : public KLined
{
   Q_OBJECT
public: 
	MyCommandLine(QWidget *parent=0, const char *name=0);
	~MyCommandLine();
 protected:
  virtual void focusInEvent(QFocusEvent*) {setCursorPosition(cursorPosition()); emit focusIn();}
  virtual void focusOutEvent(QFocusEvent*) {emit focusOut();}
  virtual void keyPressEvent(QKeyEvent* e);
 public:
  signals:
  void focusIn();
  void focusOut();
  void rollUp();
  void rollDown();
 private:
  QString _WorkingDir;
};

class MyCommandWidget : public QWidget
{
 Q_OBJECT
 public:
  MyCommandWidget(QWidget *parent=0, const char *name=0);
  MyCommandLine* getCommandLine() {return &_CommandLine;}
 protected:
  void resizeEvent(QResizeEvent*);
  void repaintCommandLine();
 public slots:
  void setWorkingDirectory(QString NewDir);
  void slotExecute();
  void slotReceivedStdout (KProcess*, char*, int);
  void slotReceivedStdErr (KProcess*, char*, int);
  void slotProcessExited  (KProcess*);
  void slotCompletion();
  void slotRotation();
  void slotTextChanged(const char*);
  void slotRollUp();
  void slotRollDown();
 private:
  MyCommandLine          _CommandLine;
  KShellProcess          _P;
  QLabel                 _DirLabel;
  QWidget*               _Parent;
  QString                _WorkingDir;
  QIntDict<QString>      _ProcessDictStdOut; //Maps process pointers on StdOut Messages
  QIntDict<QString>      _ProcessDictStdErr; //Maps process pointers on StdErr Messages
  KURLCompletion         _Completion;
  QList<QString>         _History;
  QListIterator<QString> _HistoryIt;
};

#endif
