/***************************************************************************
                          mylistviewitem.cpp  -  description                              
                             -------------------                                         
    begin                : Fri Aug 20 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <qfontmetrics.h>
#include "knc.h"

void MyListViewItem :: paintFocus( QPainter * p, const QColorGroup & cg, const QRect & r )
{
  //Draw Focus
  p->setPen(_MyListView->getFocusColor());
  p->setClipping(false);
  int contentsX = listView()->contentsX();
  QRect FocusRect(0,r.top(),r.width()+contentsX,r.height());

  p->drawLine(FocusRect.left(), FocusRect.top(), FocusRect.right(),FocusRect.top());
  p->drawLine(FocusRect.left(), FocusRect.bottom(), FocusRect.right(),FocusRect.bottom());

  //Draw Cursor
  p->setPen(_MyListView->getFocusCursorColor());
  QFontMetrics FMetrics(p->font());
  QFont f = p->font();
  QString FName = f.rawName();
  if (_MyListView->_SubString != NULL)
  {
     QRect CRect = r;
     if (pixmap(0)) contentsX -= pixmap(0)->width();
     CRect.setLeft (1+FMetrics.width(_MyListView->_SubString, _MyListView->_SubString.length())-contentsX);
     CRect.setRight (1+FMetrics.width(_MyListView->_SubString, _MyListView->_SubString.length())-contentsX);
     p->drawRect(CRect);
  }
}






