/***************************************************************************
                          pluginadmin.cpp  -  description                              
                             -------------------                                         
    begin                : Wed Oct 13 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "pluginadmin.h"
#include "generalfileplugin.h"
#include "tarfileplugin.h"
#include "iostream.h"

PluginAdmin* PluginAdmin::_instance;

PluginAdmin::PluginAdmin( )
{
  _PluginFactoryList.setAutoDelete(true);
}

PluginAdmin::~PluginAdmin()
{
}


BasePlugin* PluginAdmin::getResponsiblePlugin(QString Dir, QString SubDir)
{
  BasePlugin* RespPluginInstance = NULL;
  for (PluginIterator it(_PluginList);it.current();++it)
    if (it.current()->isResponsible(Dir,SubDir))
       RespPluginInstance = it.current();

   int Priority;
   if (RespPluginInstance) Priority = RespPluginInstance->getPluginFactory()->getPriority();
   else Priority = 0;

   for (PluginFactoryIterator it(_PluginFactoryList);it.current();++it)
   {
     if (it.current()->getPriority() > Priority)
      if (it.current()->isResponsible(Dir,SubDir))
      {
        BasePlugin* Plugin = it.current()->generatePlugin(Dir, SubDir);
        _PluginList.append(Plugin);
        return Plugin;
      }
    }
    return RespPluginInstance;
}

BasePlugin* PluginAdmin::getResponsiblePluginInstance(QString Dir, QString SubDir)
{
  for (PluginIterator it(_PluginList);it.current();++it)
    if (it.current()->isResponsible(Dir,SubDir)) return it.current();
  return NULL;
}

void PluginAdmin::unregisterPlugin(BasePlugin* Plugin)
{
  for (PluginIterator it(_PluginList);it.current();++it)
  {
    if (it.current() == Plugin)
        _PluginList.remove(Plugin);
  }
}

