/***************************************************************************
                          progressdialog.cpp  -  description                              
                             -------------------                                         
    begin                : Tue Aug 3 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "progressdialog.h"
#include "qapplication.h"
#include "kapp.h"
#include "kwm.h"
ProgressDialog::ProgressDialog(QWidget *parent, const char *name)
  : ModalDialog(NULL, name), _countFiles(0), _sizeAll(0), _countAll(0)
{
	initDialog();
  _ProgressFile->setBarStyle(KProgress::Blocked);
  _ProgressTotal->setBarStyle(KProgress::Blocked);
  setCaption(i18n("Copy/Move files"));
  update();
}

ProgressDialog::~ProgressDialog()
{
}

void ProgressDialog::set(double countFiles, double sizeAll)
{
  _countFiles = countFiles; _sizeAll = sizeAll;_countAll = 0;
}
void ProgressDialog::newFile(QString Source, QString Target, double Size)
{
 _From->setText(Source);
 _To->setText(Target);
 _sizeFile = Size;
 _ProgressFile->setValue(0);
 _countFile = 0;
}

void ProgressDialog::addSize(double Size)
{
  double newPercentageFile = (Size + _countFile)*100 / _sizeFile;
  double newPercentageAll = (Size + _countAll)*100 / _sizeAll;
  if (newPercentageFile != _PercentageFile)
  {
     _PercentageFile = newPercentageFile;
     setProgressFile(_PercentageFile);
  }
  if (newPercentageAll != _PercentageAll)
  {
     _PercentageAll = newPercentageAll;
     setProgressTotal(_PercentageAll);
  }
 _countAll += Size;
 _countFile += Size;
}






















