/***************************************************************************
                          splashscreen.cpp  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "splashscreen.h"
#include "kapp.h"
#include "qpainter.h"

SplashScreen::SplashScreen(QWidget *parent, const char *name, QString Pic, QString Message)
 : QWidget(0,name,WStyle_NoBorder | WStyle_Customize), _Message(Message)
{
  if (Pic)
  {
    QPixmap pm;
    pm.load(KApplication::kde_datadir() + Pic);
    setBackgroundPixmap(pm);
    _width = pm.width();
    _height = pm.height();
  }
  else
  {
    QFontMetrics FMetrics(font());
    _width = FMetrics.width(_Message, Message.length()) + 50;
    _height = FMetrics.height() + 50;
  }

  if (parent == 0) setGeometry(QApplication::desktop()->width()/2-200, QApplication::desktop()->height()/2-150, _width, _height);
  else
  {
    QPoint point(parent->width()/2-(_width/2),parent->height()/2-(_height/2));
    point = parent->mapToGlobal(point);
    setGeometry(point.x(), point.y(), _width, _height);
  }
  update();
}

SplashScreen::~SplashScreen()
{
}

void SplashScreen::timeout()
{
  raise();
  qApp->processEvents(2000);
  close();
}


void SplashScreen::paintEvent( QPaintEvent * )
{
  if (_Message != NULL)
  {
    QPainter p;
    p.begin( this );                        // start painting widget
    p.setPen( black );
    //  p.setBrush(  );
    p.drawRect( 1,1, _width-1,_height-1 );
    p.drawText(25, 25, _Message);
    p.end();
  }
}










