/***************************************************************************
                          tarfileplugin.h  -  description                              
                             -------------------                                         
    begin                : Tue Oct 12 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef TARFILEPLUGIN_H
#define TARFILEPLUGIN_H

#include <baseplugin.h>
#include <qlist.h>
#include <tarfileinfo.h>
#include <basepluginfactory.h>
class MyListView;
/**
  *@author Henrik Stormer
  */

class TarFilePluginFactory;

class TarFilePlugin : public BasePlugin  {
public: 
	TarFilePlugin(TarFilePluginFactory* Factory);
  virtual	~TarFilePlugin();
  virtual BasePluginFactory* getPluginFactory();
  virtual bool isResponsible(QString Path, QString SubPath);
  virtual bool create(QString Path, MyListView* ListBox, QString CurrentItemName, bool ShowHiddenFiles);
  virtual QString cdUp(QString Path, QString& Name);
  virtual QString cdDown(QString Path, QString DownPath);

  virtual void recurseSubdir(QString Dir, QList<BaseFileInfo>& FileList, double& countFiles, double& sizeAll);

  virtual void insertEntry(MyListView* ListBox, QString Dir, QString Name);
  virtual void removeEntry(MyListView* ListBox, QString Dir, QString Name);

  virtual bool sourceBeforeFileOperation(QString Path, int FO);
  virtual bool targetBeforeFileOperation(QString Path, int FO);

  virtual bool copyIn(ProgressDialog* PDialog, ST st, bool& bOverwrite, bool& bStop);

  virtual QString getType() {return "TarFilePlugin";}
  virtual TarFilePlugin* clone(QString Dir, QString SubDir) {TarFilePlugin* P = new TarFilePlugin(*this);P->_FileName = Dir+SubDir;return P;}
 protected:
  void createTarFile(QString Path);
  KTarDirectory* gotoDir(QString SubPath);
 private:
  TarFilePluginFactory* _Factory;
  KTar*                 _TarFile;
  KTar*                 _WTarFile;
  KTarDirectory*        _WorkingDir;
  QString               _FileName;
};

class TarFilePluginFactory : public BasePluginFactory
{
  public:
   TarFilePluginFactory();
   ~TarFilePluginFactory();
 virtual bool isResponsible(QString Path, QString SubPath);
 virtual BasePlugin* generatePlugin(QString Dir, QString SubDir) {return new TarFilePlugin(this);}
};


#endif





